modules

# Class: fixed_ip

Source Location: /lib/modules/fixed_ip.inc

### Class Overview

    baseModule
       |
       --fixed_ip

Manages fixed IP addresses.

#### Author(s):

- Roland Gruber

### Variables

- $attributes
- $fixed_ip
- $orig_ips
- $overlapd
- $processed

### Methods

- check_mac
- display_html_attributes
- getButtonStatus
- get_metaData
- get_pdfEntries
- load_attributes
- load_Messages
- overlapd_ip
- postModifyActions
- process_attributes
- reload_ips
- reset_overlapd_ip
- save_attributes

### Inherited Variables

#### Class: baseModule

baseModule::$autoAddObjectClasses
baseModule::$messages
baseModule::$meta
baseModule::$moduleSettings
baseModule::$orig
baseModule::$selfServiceSettings

### Inherited Methods

#### Class: baseModule

baseModule::__construct()
  Creates a new base module class
baseModule::build_uploadAccounts()
  In this function the LDAP accounts are built.
baseModule::can_manage()
  Returns true if this module can manage accounts of the current type, otherwise false.
baseModule::checkSelfServiceOptions()
  Checks if all input values are correct and returns the LDAP attributes which should be changed.
baseModule::checkSelfServiceSettings()
  Checks if the self service settings are valid.
baseModule::check_configOptions()
  Checks input values of module settings.
baseModule::check_profileOptions()
  Checks input values of account profiles.
baseModule::delete_attributes()
  This function returns an array with the same syntax as save_attributes().
baseModule::displaySpecialSelfServicePage()
  This function creates meta HTML code to display the module specific page for the self service.
baseModule::display_html_attributes()
  This function creates meta HTML code to display the module page.
baseModule::display_html_delete()
  This function creates meta HTML code which will be displayed when an account should be deleted.
baseModule::doUploadPostActions()
  This function is responsible to do additional tasks after the account has been created in LDAP (e.g. modifying group memberships, adding Quota etc..).
baseModule::getAccountContainer()
  Returns the accountContainer object.
baseModule::getAttributes()
  Returns the LDAP attributes which are managed in this module.
baseModule::getButtonStatus()
  Controls if the module button the account page is visible and activated.
baseModule::getIcon()
  Returns the path to the module icon.
baseModule::getLDAPAliases()
  Returns a list of aliases for LDAP attributes.
baseModule::getLinkToSpecialSelfServicePage()
  This allows modules to create a link to a module specific page for the self service.
baseModule::getManagedAttributes()
  Returns a list of LDAP attributes which are managed by this module.
baseModule::getManagedObjectClasses()
  Returns a list of managed object classes for this module.
baseModule::getOriginalAttributes()
  Returns the LDAP attributes which are managed in this module (with unchanged values).
baseModule::getRequiredExtensions()
  This function returns a list of PHP extensions (e.g. hash) which are needed by this module.
baseModule::getSelfServiceFields()
  Returns a list of possible input fields and their descriptions.
baseModule::getSelfServiceOptions()
  Returns the meta HTML code for each input field.
baseModule::getSelfServiceSearchAttributes()
  This function returns a list of possible LDAP attributes (e.g. uid, cn, ...) which can be used to search for LDAP objects.
baseModule::getSelfServiceSettings()
  Returns a list of self service configuration settings.
baseModule::get_alias()
  Returns an alias name for the module.
baseModule::get_configOptions()
  Returns a list of configuration options.
baseModule::get_dependencies()
  This function returns a list with all depending and conflicting modules.
baseModule::get_help()
  This function returns the help entry array for a specific help id.
baseModule::get_ldap_filter()
  Returns an LDAP filter for the account lists
baseModule::get_metaData()
  This function provides meta data which is interpreted by baseModule.
baseModule::get_pdfEntries()
  Returns the PDF entries for this module.
baseModule::get_pdfFields()
  Returns a hashtable with all entries that may be printed out in the PDF.
baseModule::get_profileOptions()
  This function defines what attributes will be used in the account profiles and their appearance in the profile editor.
baseModule::get_RDNAttributes()
  Returns a hash array containing a list of possible LDAP attributes that can be used to form the RDN (Relative Distinguished Name).
baseModule::get_scope()
  Returns the account type of this module (user, group, host)
baseModule::get_uploadColumns()
  Returns an array containing all input columns for the file upload.
baseModule::get_uploadPreDepends()
  Returns a list of module names which must be processed in building the account befor this module.
baseModule::handleAjaxRequest()
  Manages AJAX requests.
baseModule::init()
  Initializes the module after it became part of an accountContainer
baseModule::isBooleanConfigOptionSet()
  Returns if the given configuration option is set.
baseModule::is_base_module()
  Returns true if your module is a base module and otherwise false.
baseModule::load_attributes()
  This function loads the LDAP attributes when an account should be loaded.
baseModule::load_Messages()
  This function fills the $messages variable with output messages from this module.
baseModule::load_profile()
  This function loads the values from an account profile to the module's internal data structures.
baseModule::module_complete()
  This function is used to check if all settings for this module have been made.
baseModule::module_ready()
  This function is used to check if this module page can be displayed.
baseModule::postDeleteActions()
  Allows the module to run commands after the LDAP entry is deleted.
baseModule::postModifyActions()
  Allows the module to run commands after the LDAP entry is changed or created.
baseModule::postModifySelfService()
  Allows the module to run commands after the LDAP entry is changed or created.
baseModule::preDeleteActions()
  Allows the module to run commands before the LDAP entry is deleted.
baseModule::preModifyActions()
  Allows the module to run commands before the LDAP entry is changed or created.
baseModule::preModifySelfService()
  Allows the module to run commands before the LDAP entry is changed or created.
baseModule::process_attributes()
  This function processes user input.
baseModule::save_attributes()
  Returns a list of modifications which have to be made to the LDAP account.

### Class Details

[line 41]
Manages fixed IP addresses.

#### Tags:

author: | Roland Gruber

[ Top ]

### Class Variables

#### $attributes =

[line 55]

#### Tags:

access: | public

Type: | mixed
Overrides: | Array

[ Top ]

#### $fixed_ip =

[line 44]

#### Tags:

access: | public

Type: | mixed

[ Top ]

#### $orig_ips = array()

[line 53]

#### Tags:

access: | public

Type: | mixed

[ Top ]

#### $overlapd =

[line 50]

#### Tags:

access: | public

Type: | mixed

[ Top ]

#### $processed = false

[line 47]

#### Tags:

access: | public

Type: | mixed

[ Top ]

### Class Methods

### method check_mac [line 156]

`true, check_mac( mac $mac)`

Check, if a mac address is invalid

#### Tags:

return: | if mac is invalid
access: | public

#### Parameters:

mac | $mac | adress

[ Top ]

### method display_html_attributes [line 325]

`htmlElement display_html_attributes( )`

Returns the HTML meta data for the main account page.

#### Tags:

return: | HTML meta data
access: | public

Overrides baseModule::display_html_attributes() (This function creates meta HTML code to display the module page.)
[ Top ]

### method getButtonStatus [line 113]

`string getButtonStatus( )`

Controls if the module button the account page is visible and activated.

#### Tags:

return: | status ("enabled", "disabled", "hidden")
access: | public

Overrides baseModule::getButtonStatus() (Controls if the module button the account page is visible and activated.)
[ Top ]

### method get_metaData [line 64]

`array get_metaData( )`

Returns meta data that is interpreted by parent class

#### Tags:

return: | array with meta data
see: | baseModule::get_metaData()
access: | public

Overrides baseModule::get_metaData() (This function provides meta data which is interpreted by baseModule.)
[ Top ]

### method get_pdfEntries [line 519]

`array get_pdfEntries( )`

Returns the PDF entries for this module.

#### Tags:

return: | list of possible PDF entries

Overrides baseModule::get_pdfEntries() (Returns the PDF entries for this module.)
[ Top ]

### method load_attributes [line 204]

`void load_attributes( array $attr)`

This function loads all needed LDAP attributes.
Overrides baseModule::load_attributes() (This function loads the LDAP attributes when an account should be loaded.)

#### Parameters:

array | $attr | list of attributes

[ Top ]

### method load_Messages [line 104]

`void load_Messages( )`

This function fills the error message array with messages.

#### Tags:

access: | public

Overrides baseModule::load_Messages() (This function fills the $messages variable with output messages from this module.)
[ Top ]

### method overlapd_ip [line 131]

`false, overlapd_ip( ip $ip)`

Checked, if ips are overlapd.

#### Tags:

return: | if overlapd, else true.
access: | public

#### Parameters:

ip | $ip |

[ Top ]

### method postModifyActions [line 449]

`array postModifyActions( boolean $newAccount, array $attributes)`

This function is overwritten because the fixed IPs are set after the ldap_add command.

#### Tags:

return: | array which contains status messages. Each entry is an array containing the status message parameters.
see: | baseModule::postModifyActions()
access: | public

Overrides baseModule::postModifyActions() (Allows the module to run commands after the LDAP entry is changed or created.)

#### Parameters:

boolean | $newAccount |
array | $attributes | LDAP attributes of this entry

[ Top ]

### method process_attributes [line 230]

`array process_attributes( )`

Processes user input of the primary module page.

It checks if all input values are correct and updates the associated LDAP attributes.

#### Tags:

return: | list of info/error messages
access: | public

Overrides baseModule::process_attributes() (This function processes user input.)
[ Top ]

### method reload_ips [line 178]

`true, reload_ips( )`

Adapt the fixed ip with the subnet.

#### Tags:

return: | if ip were edit.
access: | public

[ Top ]

### method reset_overlapd_ip [line 145]

`void reset_overlapd_ip( )`

Reset the overlapd_range() function

#### Tags:

access: | public

[ Top ]

### method save_attributes [line 436]

`array save_attributes( )`

Returns a list of modifications which have to be made to the LDAP account.

#### Tags:

return:

list of modifications
This function returns an array with 3 entries:
array( DN1 ('add' => array($attr), 'remove' => array($attr), 'modify' => array($attr)), DN2 .... )
DN is the DN to change. It may be possible to change several DNs (e.g. create a new user and add him to some groups via attribute memberUid)
"add" are attributes which have to be added to LDAP entry
"remove" are attributes which have to be removed from LDAP entry
"modify" are attributes which have to been modified in LDAP entry
"info" are values with informational value (e.g. to be used later by pre/postModify actions)

access: | public

Overrides baseModule::save_attributes() (Returns a list of modifications which have to be made to the LDAP account.)
[ Top ]

Documentation generated on Sun, 25 Mar 2012 19:35:34 +0200 by phpDocumentor 1.4.1